#Dieser Program sammelt Daten und erkennt Bewegung. Die gemessene
#Temperatur wird in Zeit Intervalen von der Variable "ZeitTemp"
#gemessen. Die Photos zur Bewegungserkennung werden in Zeit
#Intervalle von "ZeitCam" gemessen.

from multiprocessing import Process

import requests, json, base64, io, picamera,sys,subprocess,os,time
import cv2, io, time, copy, Adafruit_DHT
import numpy as np
import RPi.GPIO as GPIO

import Functions as func
import TreeDBInterface as tree

host1='http://treedb.eu-gb.mybluemix.net'
#host='http://treedb.info/TreeDB'
host='http://test.treedb.at/TreeDB'

headers = {'Content-type': 'application/json' , 'charset':'utf-8'}
urlLong = host +'/rest/data/long'
urlString = host +'/rest/data/string'
urlDouble = host +'/rest/data/double'
urlBinary = host +'/rest/data/binary'
urlBase =  host +'/rest/data/'

urlLong1 = host1 +'/rest/data/long'
urlString1 = host1 +'/rest/data/string'
urlDouble1 = host1 +'/rest/data/double'
urlBinary1 = host1 +'/rest/data/binary'
urlBase1 =  host1 +'/rest/data/'


domain = tree.get_domain(urlBase,'dataLoggingDB')



def motDet_loop(pictures,t):
	sensor4 = tree.get_sensor(urlBase,'dataLoggingDB','pi1_cam')
	sensor4Sequence= 3
	a, img=func.motDetInit(pictures,t)
	if a!=False:
		img= base64.b64encode(img).decode('utf-8')
		data = json.dumps({"domain":domain, "sensor":sensor4,"sequence":sensor4Sequence,"value": img ,"mimeType":"image/jpg"})
		r = requests.post(urlBinary, data,headers =headers)
	while True:
		a, img=func.motDetCont(pictures,t)
		sensor4Sequence+= 1
		if a!=False:
			img= base64.b64encode(img).decode('utf-8')
			data = json.dumps({"domain":domain, "sensor":sensor4,"sequence":sensor4Sequence,"value": img ,"mimeType":"image/jpg"})
			r = requests.post(urlBinary, data,headers =headers)

def measureAndSend_loop(t):
	while True:

		sensor1 = tree.get_sensor(urlBase,'dataLoggingDB','pi1_sensor1')
		sensor2 = tree.get_sensor(urlBase,'dataLoggingDB','pi1_sensor2')
		sensor3 = tree.get_sensor(urlBase,'dataLoggingDB','pi1_cpu')
		sensor5 = tree.get_sensor(urlBase,'dataLoggingDB','pil_sensor5')
		sensor6 = tree.get_sensor(urlBase,'dataLoggingDB','pil_sensor6')

		sensor1Sequence = 0
		sensor2Sequence = 0
		sensor3Sequence = 0
		sensor5Sequence = 0
		sensor6Sequence = 0


		
		#get sensor temperature
		x1 = func.get_sensor_temp(1)
		x2 = func.get_sensor_temp(2)
		x3 = func.get_hygrometer_temp(1)
		#and humidity
		x4 = func.get_hygrometer_humidity(1)
		cpu_t = func.get_temperature()

		print(x1)
		print(x2)
		print(x3)
		print(x4)
		print(cpu_t)

		#send data from sensors
		# extern sensor1
		data=json.dumps({"domain":domain, "sensor":sensor1,"sequence":sensor1Sequence,"value":x1})
		r = requests.post(urlDouble, data,headers =headers)

		data=json.dumps({"domain":domain, "sensor":sensor2,"sequence":sensor2Sequence,"value":x2})
		r = requests.post(urlDouble, data,headers =headers)
		
		data=json.dumps({"domain":domain, "sensor":sensor3,"sequence":sensor3Sequence,"value":cpu_t})
		r = requests.post(urlDouble, data,headers =headers)
      
		data=json.dumps({"domain":domain, "sensor":sensor5,"sequence":sensor5Sequence,"value":x3})
		r = requests.post(urlDouble, data,headers =headers)

		data=json.dumps({"domain":domain, "sensor":sensor6,"sequence":sensor6Sequence,"value":x4})
		r = requests.post(urlDouble, data,headers =headers)

		sensor1Sequence+= 1
		sensor2Sequence+= 1
		sensor3Sequence+= 1
		sensor5Sequence+= 1
		sensor6Sequence+= 1

		#time Delay
		time.sleep(t)

def smoke_loop(t):
	try:
		sensor7 = tree.get_sensor(urlBase,'dataLoggingDB','pi1_sensor2')
		sensor7Sequence=0
		while True:
			weak=func.getADC(0)
			strong=func.getADC(1)
			if strong==1:
				x7="Strong Smoke Alarm triggered!!!"
				print "Strong Smoke Alarm triggered!!!"
				data=json.dumps({"domain":domain, "sensor":sensor7,"sequence":sensor7Sequence,"value":x7})
				r = requests.post(urlString, data,headers =headers)
			elif weak==1:
				x7="Weak Smoke Alarm triggered!!!"
				print "Weak Smoke Alarm triggered!!!"
				data=json.dumps({"domain":domain, "sensor":sensor7,"sequence":sensor7Sequence,"value":x7})
				r = requests.post(urlString, data,headers =headers)
			else:
				pass
	
			sensor7Sequence+=1
			time.sleep(1)	
	except KeyboardInterrupt:
		print "Exiting..."
		sys.exit()

######################################################################


ZeitTemp=5*60
ZeitCam=1
ZeitSmoke=1
pictures=[0,0,0]

p1=Process(target=motDet_loop,args=(pictures,ZeitCam))
p2=Process(target=measureAndSend_loop,args=(ZeitTemp,))
p3=Process(target=smoke_loop,args=(ZeitSmoke,))
try:
	p1.start()
	p2.start()
	p3.start()
except KeyboardInterrupt:
	print "Exiting..."
	sys.exit()

