# Domain ID:3
# Sensor 1 ID:77
# Sensor 2 ID:78
#SensorType ID:55


import requests, json, base64, io, picamera,sys,subprocess,os

#host='http://treedb.eu-gb.mybluemix.net'
#host='http://192.168.123.21:8080/TreeDB'
host='http://test.treedb.at/TreeDB'

headers = {'Content-type': 'application/json' , 'charset':'utf-8'}
urlLong = host +'/rest/data/long'
urlString = host +'/rest/data/string'
urlDouble = host +'/rest/data/double'
urlBinary = host +'/rest/data/binary'
urlBase =  host +'/rest/data/'

#print(urlDomain)


def get_domain(domain):
	payload = {'domain': domain }
	r = requests.get(urlBase + 'domain', params=payload)
	return r.text

def get_sensor(domain,sensor):
        payload = {'domain': domain,'sensor': sensor }
        r = requests.get(urlBase + 'sensor', params=payload)
        return r.text


def get_cam():
        # Create the in-memory stream
        stream = io.BytesIO()
        with picamera.PiCamera() as camera:
                camera.resolution = (640, 480)
                camera.capture(stream, format='jpeg')
        stream.seek(0)
        b = stream.read(-1)
        b64 = base64.b64encode(b).decode('utf-8')
        return b64;

def get_temperature():
    s = subprocess.check_output(['/opt/vc/bin/vcgencmd','measure_temp']).decode('utf-8')
    return int(float(s.split('=')[1][:-3]))

sensor1 = get_sensor('dataLoggingDB','Sensor 1')
sensor2 = get_sensor('dataLoggingDB','Sensor 2')
domain = get_domain('dataLoggingDB')

print("Sensor " + sensor1);

# write double value
data = json.dumps({"domain":domain, "sensor":sensor1,"sequence":2,"value":4.555})
r = requests.post(urlDouble, data,headers =headers)

# write long value
data = json.dumps({"domain":domain, "sensor":sensor2,"sequence":2,"value": get_temperature()})
r = requests.post(urlLong, data,headers =headers)



# write string data with special chars - chinese characters for the big panda
data = json.dumps({"domain":domain, "sensor":sensor2,"sequence":2,"value":"大熊猫 żeń–szeń"}) 
r = requests.post(urlString, data,headers =headers)

# write string data with special chars - polish exmaple from my wife
data = json.dumps({"domain":domain, "sensor":sensor1,"sequence":2,"value":"współdźwięczność"}) 
r = requests.post(urlString, data,headers =headers)

# write binary data - still image from the cam
data = json.dumps({"domain":domain, "sensor":sensor2,"sequence":222,"value": get_cam() ,"mimeType":"image/jpg"})
r = requests.post(urlBinary, data,headers =headers)


print (r.json)



